# w.c.s. - web application for online forms
# Copyright (C) 2005-2011  Entr'ouvert
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, see <http://www.gnu.org/licenses/>.

from quixote import get_publisher, get_request, get_response, get_session

from wcs.carddef import CardDef
from wcs.workflows import AbortActionException, WorkflowStatusItem, register_item_class

from ..qommon import _


class RemoveWorkflowStatusItem(WorkflowStatusItem):
    description = _('Deletion')
    key = 'remove'
    category = 'formdata-action'

    def perform(self, formdata):
        formdata.remove_self()
        if get_request() and get_response().filter.get('in_backoffice'):
            if isinstance(formdata.formdef, CardDef):
                get_session().message = ('info', _('The card has been deleted.'))
            else:
                get_session().message = ('info', _('The form has been deleted.'))
            url = '..'
        else:
            url = get_publisher().get_frontoffice_url()
        raise AbortActionException(url=url)


register_item_class(RemoveWorkflowStatusItem)
